*** /tmp/extdiff.j8rRhu/gmp-main.89ed9376523e/longlong.h	Thu Jun 11 15:53:20 2020
--- /home/tege/prec/gmp-main/longlong.h	Wed Jun 17 20:13:14 2020
***************
*** 437,441 ****
  #define add_ssaaaa(sh, sl, ah, al, bh, bl) \
    do {									\
!     if (__builtin_constant_p (bl) && -(USItype)(bl) < 0x100)		\
        __asm__ ("subs\t%1, %4, %5\n\tadc\t%0, %2, %3"			\
  	   : "=r" (sh), "=&r" (sl)					\
--- 437,441 ----
  #define add_ssaaaa(sh, sl, ah, al, bh, bl) \
    do {									\
!     if (__builtin_constant_p (bl) && -(USItype)(bl) < (USItype)(bl))	\
        __asm__ ("subs\t%1, %4, %5\n\tadc\t%0, %2, %3"			\
  	   : "=r" (sh), "=&r" (sl)					\
***************
*** 448,453 ****
    } while (0)
  /* FIXME: Extend the immediate range for the low word by using both ADDS and
!    SUBS, since they set carry in the same way.  Note: We need separate
!    definitions for thumb and non-thumb to to th absense of RSC under thumb.  */
  #if defined (__thumb__)
  #define sub_ddmmss(sh, sl, ah, al, bh, bl) \
--- 448,453 ----
    } while (0)
  /* FIXME: Extend the immediate range for the low word by using both ADDS and
!    SUBS, since they set carry in the same way.  We need separate definitions
!    for thumb and non-thumb since thumb lacks RSC.  */
  #if defined (__thumb__)
  #define sub_ddmmss(sh, sl, ah, al, bh, bl) \
***************
*** 462,469 ****
  	       : "=r" (sh), "=&r" (sl)					\
  	       : "r" (ah), "rI" (bh), "rI" (al), "r" (bl) __CLOBBER_CC); \
-     else if (__builtin_constant_p (bl))					\
-       __asm__ ("subs\t%1, %4, %5\n\tsbc\t%0, %2, %3"			\
- 	       : "=r" (sh), "=&r" (sl)					\
- 	       : "r" (ah), "rI" (bh), "r" (al), "rI" (bl) __CLOBBER_CC); \
      else								\
        __asm__ ("subs\t%1, %4, %5\n\tsbc\t%0, %2, %3"			\
--- 462,465 ----
***************
*** 501,512 ****
  		   : "rI" (ah), "r" (bh), "rI" (al), "r" (bl) __CLOBBER_CC); \
        }									\
!     else if (__builtin_constant_p (bl))					\
        __asm__ ("subs\t%1, %4, %5\n\tsbc\t%0, %2, %3"			\
  	       : "=r" (sh), "=&r" (sl)					\
  	       : "r" (ah), "rI" (bh), "r" (al), "rI" (bl) __CLOBBER_CC); \
-     else /* only bh might be a constant */				\
-       __asm__ ("subs\t%1, %4, %5\n\tsbc\t%0, %2, %3"			\
- 	       : "=r" (sh), "=&r" (sl)					\
- 	       : "r" (ah), "rI" (bh), "r" (al), "rI" (bl) __CLOBBER_CC); \
      } while (0)
  #endif
--- 497,504 ----
  		   : "rI" (ah), "r" (bh), "rI" (al), "r" (bl) __CLOBBER_CC); \
        }									\
!     else								\
        __asm__ ("subs\t%1, %4, %5\n\tsbc\t%0, %2, %3"			\
  	       : "=r" (sh), "=&r" (sl)					\
  	       : "r" (ah), "rI" (bh), "r" (al), "rI" (bl) __CLOBBER_CC); \
      } while (0)
  #endif
***************
*** 565,569 ****
  #define add_ssaaaa(sh, sl, ah, al, bh, bl) \
    do {									\
!     if (__builtin_constant_p (bl) && -(UDItype)(bl) < 0x1000)		\
        __asm__ ("subs\t%1, %x4, %5\n\tadc\t%0, %x2, %x3"			\
  	       : "=r" (sh), "=&r" (sl)					\
--- 557,561 ----
  #define add_ssaaaa(sh, sl, ah, al, bh, bl) \
    do {									\
!     if (__builtin_constant_p (bl) && ~(UDItype)(bl) <= (UDItype)(bl))	\
        __asm__ ("subs\t%1, %x4, %5\n\tadc\t%0, %x2, %x3"			\
  	       : "=r" (sh), "=&r" (sl)					\
***************
*** 578,582 ****
  #define sub_ddmmss(sh, sl, ah, al, bh, bl) \
    do {									\
!     if (__builtin_constant_p (bl) && -(UDItype)(bl) < 0x1000)		\
        __asm__ ("adds\t%1, %x4, %5\n\tsbc\t%0, %x2, %x3"			\
  	       : "=r,r" (sh), "=&r,&r" (sl)				\
--- 570,574 ----
  #define sub_ddmmss(sh, sl, ah, al, bh, bl) \
    do {									\
!     if (__builtin_constant_p (bl) && ~(UDItype)(bl) <= (UDItype)(bl))	\
        __asm__ ("adds\t%1, %x4, %5\n\tsbc\t%0, %x2, %x3"			\
  	       : "=r,r" (sh), "=&r,&r" (sl)				\
***************
*** 1491,1504 ****
  		 __CLOBBER_CC);						\
    } while (0)
- /* We use "*rI" for the constant operand here, since with just "I", gcc barfs.
-    This might seem strange, but gcc folds away the dead code late.  */
  #define sub_ddmmss(sh, sl, ah, al, bh, bl) \
    do {									\
!     if (__builtin_constant_p (bl) && bl > -0x8000 && bl <= 0x8000) {	\
  	if (__builtin_constant_p (ah) && (ah) == 0)			\
  	  __asm__ ("addic %1,%3,%4\n\tsubfze %0,%2"			\
  		   : "=r" (sh), "=&r" (sl)				\
  		   :                       "r" ((UDItype)(bh)),		\
! 		     "rI" ((UDItype)(al)), "*rI" (-((UDItype)(bl)))	\
  		     __CLOBBER_CC);					\
  	else if (__builtin_constant_p (ah) && (ah) == ~(UDItype) 0)	\
--- 1483,1495 ----
  		 __CLOBBER_CC);						\
    } while (0)
  #define sub_ddmmss(sh, sl, ah, al, bh, bl) \
    do {									\
!     if (__builtin_constant_p (bl)					\
! 	&& (bl) > -0x8000 && (bl) <= 0x8000 && (bl) != 0) {		\
  	if (__builtin_constant_p (ah) && (ah) == 0)			\
  	  __asm__ ("addic %1,%3,%4\n\tsubfze %0,%2"			\
  		   : "=r" (sh), "=&r" (sl)				\
  		   :                       "r" ((UDItype)(bh)),		\
! 		     "r" ((UDItype)(al)), "*rI" (-((UDItype)(bl)))	\
  		     __CLOBBER_CC);					\
  	else if (__builtin_constant_p (ah) && (ah) == ~(UDItype) 0)	\
***************
*** 1506,1528 ****
  		   : "=r" (sh), "=&r" (sl)				\
  		   :                       "r" ((UDItype)(bh)),		\
! 		     "rI" ((UDItype)(al)), "*rI" (-((UDItype)(bl)))	\
  		     __CLOBBER_CC);					\
  	else if (__builtin_constant_p (bh) && (bh) == 0)		\
  	  __asm__ ("addic %1,%3,%4\n\taddme %0,%2"			\
  		   : "=r" (sh), "=&r" (sl)				\
! 		   : "r"  ((UDItype)(ah)),				\
! 		     "rI" ((UDItype)(al)), "*rI" (-((UDItype)(bl)))	\
  		     __CLOBBER_CC);					\
  	else if (__builtin_constant_p (bh) && (bh) == ~(UDItype) 0)	\
  	  __asm__ ("addic %1,%3,%4\n\taddze %0,%2"			\
  		   : "=r" (sh), "=&r" (sl)				\
! 		   : "r"  ((UDItype)(ah)),				\
! 		     "rI" ((UDItype)(al)), "*rI" (-((UDItype)(bl)))	\
  		     __CLOBBER_CC);					\
  	else								\
  	  __asm__ ("addic %1,%4,%5\n\tsubfe %0,%3,%2"			\
  		   : "=r" (sh), "=&r" (sl)				\
! 		   : "r"  ((UDItype)(ah)), "r" ((UDItype)(bh)),		\
! 		     "rI" ((UDItype)(al)), "*rI" (-((UDItype)(bl)))	\
  		     __CLOBBER_CC);					\
      } else {								\
--- 1497,1519 ----
  		   : "=r" (sh), "=&r" (sl)				\
  		   :                       "r" ((UDItype)(bh)),		\
! 		     "r" ((UDItype)(al)), "*rI" (-((UDItype)(bl)))	\
  		     __CLOBBER_CC);					\
  	else if (__builtin_constant_p (bh) && (bh) == 0)		\
  	  __asm__ ("addic %1,%3,%4\n\taddme %0,%2"			\
  		   : "=r" (sh), "=&r" (sl)				\
! 		   : "r" ((UDItype)(ah)),				\
! 		     "r" ((UDItype)(al)), "*rI" (-((UDItype)(bl)))	\
  		     __CLOBBER_CC);					\
  	else if (__builtin_constant_p (bh) && (bh) == ~(UDItype) 0)	\
  	  __asm__ ("addic %1,%3,%4\n\taddze %0,%2"			\
  		   : "=r" (sh), "=&r" (sl)				\
! 		   : "r" ((UDItype)(ah)),				\
! 		     "r" ((UDItype)(al)), "*rI" (-((UDItype)(bl)))	\
  		     __CLOBBER_CC);					\
  	else								\
  	  __asm__ ("addic %1,%4,%5\n\tsubfe %0,%3,%2"			\
  		   : "=r" (sh), "=&r" (sl)				\
! 		   : "r" ((UDItype)(ah)), "r" ((UDItype)(bh)),		\
! 		     "r" ((UDItype)(al)), "*rI" (-((UDItype)(bl)))	\
  		     __CLOBBER_CC);					\
      } else {								\
